; Format (Counter / Number):
;	Function.b = Difference To get next Function
;	Or $FF, add $FF and read next byte
; Reloc:
;	Reloc

; Read the next compressed/uncompressed word.
; In:
;	d0.l = Free (Destroyed)
;	d1.l = Used  (Can be freed)
;	d2.l = Counter 1
;	d3.l = Last Read Word (*)
;	d4.l = Reloc Addr
;	d5.l = Counter 2
;	d6.l = Program Size
;	d7.l = Flags : Relocation (1) / Recursive ($8000) / Compressed ($80000000)

;	a0 -> Address of current Library / unused
;	a1 -> Address of Base Exported Functions of lib / unused (Can be freed)
;	a2 -> 
;	a3 -> Library Name Ptr / RomCall Ptr / RamCall Ptr
;	a4 -> Word Table (*)
;	a5 -> Program reference
;	a6 -> Data Ptr

;Out:
;	d3.l = New Read Word or ZERO if end of table
;	a4 -> Next section
; Destroy:
;	d4 / a4
; Add 4 to d3.l (Auto advance ?)
; Pb: x2.

ReadNextWordAdd4:
	addq.w	#4,d3
ReadNextWord:
	move.l	d7,d0
	bge.s	\Uncompressed
	; Check if nibbles count
	add.l	d0,d0
	bcc.s	\Next
		bmi.s	\NibblesAlready
			; Read Next Nibble Pair
			moveq	#$F,d3			; Mask
			move.b	(a4)+,d2		; Get next pair 
			and.w	d2,d3			; d3 = Low Bits
			lsr.b	#4,d2			; get high nibble (d2.w is cleared)
			add.w	d2,a6			; add delta to address \ times
			add.w	d2,a6			; add delta to address /  two
			add.l	d4,(a6)+		; Path this address
			add.w	d3,a6			; add delta to address \ times
			add.w	d3,a6			; add delta to address /  two
			add.l	d4,(a6)+		; Path this address
		
			
\NibblesAlready:
		clr.w	d0
		move.b	Nibble-FirstRun(a6),d0
;		rol.l	#7,d0
;		andi.w	#$FF,d0
		add.w	d0,d3
		bclr.l	#30,d7
		
		move.b	NibbleCount-FirstRun(a6),d0	; Pb: Recursive !
		subq.b	#1,d0
		blt.s	\NibbleEnd
			move.b	d0,NibbleCount-FirstRun(a6)
			rts
\NibbleEnd	bclr.l	#31,d7
		rts

	; No so read next char
\Next	clr.w	d0
	move.b	(a4)+,d0		; Read first Byte
	beq.s	\zero			; =0 => End of Reloc Table
	add.b	d0,d0			; x2
	bcc.s	\byte			; If no carry, then it is a byte index
	bmi.s	\word			; If < 0, then it is a word index.

\nibbles:	moveq	#$1E,d2		; Else it is the start of a nibble table			
		and.w	d0,d2		; Low Bits: delta (Bit 0 ?)
		lsr.b	#5,d0		; High Bits: Size of Nibble Table
		add.w	d2,d3		; add delta to Offset
		bset.l	#31,d7		; Flags for Nibbles Count
		move.b	d0,NibbleCount-FirstRun(a6)	; Set Nibble counter
		rts
		
\word:		lsl.w	#7,d0		; d0.w *= 128 (We did already x2).
		move.b	(a4)+,d0	; Get Low Part
		lsl.w	#2,d0		; High bits disapeared
		lsr.w	#1,d0		; Restore index
		add.w	d0,d3		; add delta to address
		add.w	#$7F*2,d3	; add rest of delta (Since we will use Byte index instead)
		cmp.w	#$7FFE,d0	; Check special TAG (Do not path but just another word).
		beq.s	\Next
		rts

\byte:		add.w	d0,d3
		subq.w	#2,d3
		rts
		
\zero:		clr.w	d3
		rts

\Uncompressed:	move.w	(a4)+,d3
		rts

;----------------------------------------------------------------------------
; do_reloc(): parse compressed relocation table
;
; In:
;	a4 -> Offset Table
;	d4.l = Value to add (or to sub)
;	d7 = Relocation / Unrelocation mode
;	a5 -> Program reference
;	d6 = Program Size
;Out:
;	Program relocated
;	a4 -> Next section
; Destroy:
;	d4 / a4
; Use a Callback ?
do_reloc:
	RELOC_MAC	d4		; If relocation, d4 =d4. If Unrelocation, d4 =~d4
	movem.l	d2/d3/a6,-(a7)
	lea	$18(a5),a6		; First Address (Fix it with _main: rts)
\loop:
	clr.w	d0
	move.b	(a4)+,d0		; Read first Byte
	beq.s	\ret			; =0 => End of Reloc Table
	add.b	d0,d0			; x2
	bcc.s	\byte			; If carry, then it is a byte index
	bmi.s	\word			; If < 0, then it is a word index.
\nibbles:				; Else it is the start of a nibble table
	moveq	#$1E,d2			
	and.w	d0,d2			; Low Bits: delta (Bit 0 ?)
	lsr.b	#5,d0			; High Bits: Size of Nibble Table
	add.w	d2,a6			; add delta to address
	add.l	d4,(a6)+		; Path this address
\nibble_loop:
	moveq	#$F,d3			; Mask
	move.b	(a4)+,d2		; Get next pair 
	and.w	d2,d3			; d3 = Low Bits
	lsr.b	#4,d2			; get high nibble (d2.w is cleared)
	add.w	d2,a6			; add delta to address \ times
	add.w	d2,a6			; add delta to address /  two
	add.l	d4,(a6)+		; Path this address
	add.w	d3,a6			; add delta to address \ times
	add.w	d3,a6			; add delta to address /  two
	add.l	d4,(a6)+		; Path this address
	dbf	d0,\nibble_loop
	bra.s	\loop

\word:	lsl.w	#7,d0			; d0.w *= 128 
	move.b	(a4)+,d0		; Get Low Part
	lsl.w	#2,d0			; High bits disapeared
	lsr.w	#1,d0			; Restore index
	add.w	d0,a6			; add delta to address
	lea	$7F*2(a6),a6		; add rest of delta (Since we will use Byte index instead)
	cmp.w	#$7FFE,d0		; Check special TAG (Do not path but just advanced a6).
	beq.s	\loop
	add.l	d4,(a6)+		; Path this address
	bra.s	\loop

\byte:	lea	-2(a6,d0.w),a6		; add delta to address
	add.l	d4,(a6)+		; Path this address
	bra.s	\loop

\ret:	movem.l	(a7)+,d2/d3/a6
	rts



static long DoNibbles(char *Data, long Offset, int nibble_count)
{
  long src = Offset -= nibble_count;
  while (nibble_count >= 3) {
    int n = (nibble_count - 1) / 2;
    if (n > 4) n = 4;
    nibble_count -= n * 2 + 1;
    if (Data)
      Data[Offset] = ((8 + n - 1) << 4) | (Data[src++] - 1);
    Offset += 1;
    if (Data) {
      while (--n >= 0) {
	Data[Offset++] = (((Data[src] - 1) << 4) |
			 ((Data[src + 1] - 1)));
	src += 2;
      }
    }
    else
      Offset += n;
  }
  if (Data) {
    while (nibble_count > 0) {
      Data[Offset++] = Data[src++];
      nibble_count--;
    }
  }
  else
    Offset += nibble_count;
  return Offset;
}

static int CmpLong(const void *e1, const void *e2)
{
	return (*(long *)e1) - (*(long *)e2);
}

static long DumpReloc(long Reloc[], long Num, char *Data, long Offset)
{
  long last = 0x18, i;
  int nibble_count = 0;
  
  qsort(Reloc, Num, sizeof(long), CmpLong);
  
  for(i = 0 ; i < Num ; i++ ) {
    unsigned short diff = (Reloc[i] - last) / 2;
    while (TRUE) {
      if (diff < 0x10) {
	if (Data)
		Data[Offset] = diff + 1;
	Offset++;
	nibble_count++;
	break;
      }
      else {
	Offset = DoNibbles(Data, Offset, nibble_count);
	nibble_count = 0;
	if (diff < 0x7F) {
	  if (Data)
	  	Data[Offset] = diff + 1;
	  Offset++;
	  break;
	}
	else {
	  diff -= 0x7F;
	  if (diff > 0x3FFF) {
	    if (Data)
	    	{
	    	Data[Offset] = 0xFF;
	    	Data[Offset+1] = 0xFF;
		}
	    Offset += 2;
	    diff -= 0x3FFF;
	  }
	  else {
	    if (Data)
	    	{
	    	diff += 0xC000;
	    	Data[Offset] = diff >> 8;
	    	Data[Offset+1] = diff & 0xFF;
	    	}
	    Offset += 2;
	    break;
	  }
	}
      }
    }
    last = Reloc[i] + 4;
  }
  Offset = DoNibbles(Data, Offset, nibble_count);
  if (Data)
  	Data[Offset] = 0;
  Offset += 1;
  return Offset;
}

