/*
 * Warning the header file is NOT SUPPORTED BY TIGCC TEAM
 * I think it is the best file to use if you want to use 
 * Kernel format.
 *
 * How to use ?
 *	Instead of :
 *	#define USE_KERNEL
 *	#include <tigcclib.h>
 * Just do :
 *	#include <kernel.h>
 * (You can forget to define the targets).
 * To return a value, just add:
 *	RETURN_VALUE;
 * 	just after you have pushed the returned value in the estack.
 *	(Contrary to tigcclib, you can not return a value if you want).
 */

#ifdef NOSTUB
#error "kernel.h" must not be included in "nostub" mode!
#endif

#ifndef DOORS
#define DOORS

// if no target are defined, compiled for all calcs
#ifndef USE_TI92PLUS
#ifndef USE_TI89
#ifndef USE_V200
#define USE_TI92PLUS
#define	USE_TI89
#define USE_V200
#endif
#endif
#endif

#undef	NO_AMS_CHECK				// Useless in Kernel mode (Kernel does the job for you).
#undef	NO_CALC_DETECT				// Useless in Kernel mode (Kernel does the job for you).
#undef	EXECUTE_IN_GHOST_SPACE			// Useless in Kernel mode 
#undef	USE_KERNEL				
#undef	USE_INTERNAL_FLINE_EMULATOR		// Useless with Preos
#undef	RETURN_VALUE				// Change the way of working

#define	NO_AMS_CHECK
#define	NO_CALC_DETECT
#define	USE_KERNEL

#include <default.h>
#include <romsymb.h>

// You can't no select Exit support 
#undef	_main
#define _main volatile __main__(); \
	asm(	".xdef	_main\n" \
		"	.xdef	__save__sp__\n" \
		"__save__sp__:\n" \
		"	.long 0\n" \
		"_main:	lea __save__sp__(%pc),%a0\n" \
		"	move.l %a7,(%a0)\n" \
		"	jbra	___main\n"); \
	 void ___main

#endif

#include <tigcclib.h>

#ifndef	KERNEL
#define KERNEL

// Even if I include tigcclib above, I prefer redefining HANDLE
#undef HANDLE
#define HANDLE unsigned short

// Kernel RAM_CALLS
extern void
	_RAM_CALL_0,_RAM_CALL_1,_RAM_CALL_2,_RAM_CALL_3,
	_RAM_CALL_4,_RAM_CALL_5,_RAM_CALL_6,_RAM_CALL_7,
	_RAM_CALL_8,_RAM_CALL_9,_RAM_CALL_A,_RAM_CALL_B,
	_RAM_CALL_C,_RAM_CALL_D,_RAM_CALL_E,_RAM_CALL_F,
	_RAM_CALL_10,_RAM_CALL_11,_RAM_CALL_12,_RAM_CALL_13,
	_RAM_CALL_14,/*_RAM_CALL_15,
	_RAM_CALL_16,_RAM_CALL_17,_RAM_CALL_18,_RAM_CALL_19,
	_RAM_CALL_1A,_RAM_CALL_1B,_RAM_CALL_1C,_RAM_CALL_1D,
	_RAM_CALL_1E,_RAM_CALL_1F,_RAM_CALL_20,*/_RAM_CALL_21,
	_RAM_CALL_22,_RAM_CALL_23,_RAM_CALL_24,_RAM_CALL_25,
	_RAM_CALL_26,_RAM_CALL_27,_RAM_CALL_28/*,_RAM_CALL_29*/;

// Symbols preceed with '_' are used for the implementation
// Do not use them.
#define ___RAM_CALL(n,type) ((type)&_RAM_CALL_##n)

#define __CALCULATOR ___RAM_CALL(0, const unsigned char*)
#undef	CALCULATOR
#undef	HW_VERSION
#define CALCULATOR	(__CALCULATOR[0])
#define HW_VERSION	(__CALCULATOR[1])
//#define HW_DISPLAY_VERSION (__CALCULATOR[2])
#define EMULATOR	(__CALCULATOR[3])

#undef	font_medium
#undef	font_small
#undef	font_large
#define font_medium	___RAM_CALL(E, const void*)
#define font_small	___RAM_CALL(22, const void*)
#define font_large	___RAM_CALL(23, const void *)

#undef	LCD_MEM
#undef	LCD_WIDTH
#undef	LCD_HEIGHT
#undef	LCD_LINE_BYTES
#define	LCD_MEM		___RAM_CALL(21, void*)
#define LCD_WIDTH	___RAM_CALL (1, unsigned long)
#define LCD_HEIGHT	___RAM_CALL (2, unsigned long)
#define LCD_LINE_BYTES	___RAM_CALL (4, unsigned long)
#define _LCD_SIZE	___RAM_CALL (C, unsigned long)

#undef	ROM_BASE
#define	ROM_BASE	___RAM_CALL(3, unsigned char *)

#define	RETURN_VALUE	((unsigned char *) *_RAM_CALL_F = (unsigned char *) *_ROM_CALL_109)

#undef	Heap
#undef	FOLDER_LIST_HANDLE
#undef	MainHeandle
#undef	ROM_VERSION
#define Heap		___RAM_CALL(11, void***)
#define FOLDER_LIST_HANDLE ___RAM_CALL (12, unsigned long)
#define MainHandle	___RAM_CALL (13, unsigned long)
#define ROM_VERSION	___RAM_CALL (14, unsigned long)

#undef	kb_globals
#undef	KEY_PRESSED_FLAG
#undef	GETKEY_CODE
#define kb_globals	___RAM_CALL(10, void*)
#define KEY_PRESSED_FLAG (*(unsigned short*)(kb_globals+0x1C))
#define GETKEY_CODE	(*(unsigned short*)(kb_globals+0x1E))

#undef	KEY_LEFT
#undef	KEY_RIGHT
#undef	KEY_UP
#undef	KEY_DOWN
#undef	KEY_UPRIGHT
#undef	KEY_DOWNLEFT
#undef	KEY_DIAMOND
#undef	KEY_SHIFT
#define KEY_LEFT	___RAM_CALL(5, unsigned long)
#define KEY_RIGHT	___RAM_CALL(6, unsigned long)
#define KEY_UP		___RAM_CALL(7, unsigned long)
#define KEY_DOWN	___RAM_CALL(8, unsigned long)
#define KEY_UPRIGHT	___RAM_CALL(9, unsigned long)
#define KEY_DOWNLEFT	___RAM_CALL(A, unsigned long)
#define KEY_DIAMOND	___RAM_CALL(B, unsigned long)
#define KEY_SHIFT	___RAM_CALL(D, unsigned long)

#define	Idle	_RAM_CALL_15
#define kernel_Idle Idle
void	Idle(void);
#define	kernel_Exec	_RAM_CALL_16
short kernel_Exec(HANDLE hd asm("d0"));
#define	kernel_Ptr2Hd	_RAM_CALL_17
HANDLE kernel_Ptr2Hd(void *ptr asm("a0"));
#define	kernel_Hd2Sym	_RAM_CALL_18
SYM_ENTRY *kernel_Hd2Sym(HANDLE hd asm("d0"));
typedef	struct _LibRef LibRef;
#define	kernel_LibsBegin _RAM_CALL_19
LibRef *kernel_LibsBegin(char *libname asm("a0"), unsigned char version asm("d1"));
#define kernel_LibsEnd	_RAM_CALL_1A
void kernel_LibsEnd(LibRef *lib asm("a0"));
#define	kernel_LibsPtr	_RAM_CALL_1C
void *kernel_LibsPtr(LibRef *lib asm("a0"), short function asm("d0"));
#define	kernel_LibsCall	_RAM_CALL_1B
__attribute__((__stkparm__)) unsigned long kernel_LibsCall(LibRef *lib, short function, ...);
#define	kernel_LibsExec	_RAM_CALL_1D
__attribute__((__stkparm__)) void kernel_LibsExec(char *name, short function, char version, ...);
#define	kernel_HdKeep	_RAM_CALL_1E
void	kernel_HdKeep(HANDLE hd asm("d0"));
#define	kernel_ExtractFromPack	_RAM_CALL_1F
HANDLE	kernel_ExtractFromPack(void *pack asm("a5"), short index asm("d0"));
#define	kernel_ExtractFile	_RAM_CALL_20
HANDLE	kernel_ExtractFile(const char *name asm("a2"));
#define	kernel_ExtractFileFromPack	_RAM_CALL_29
HANDLE	kernel_ExtractFileFromPack(HANDLE hd asm("d0"), const char *name asm("a2"));

/* Sym_entry compatible with all calcs (even ti-92)
 *
 * SYM_ENTRY.name
 * SYM_ENTRY.compat
 * SYM_ENTRY.flags
 * SYM_ENTRY.hVal
 * SYM_ENTRY.sizeof
 */

// graphlib
asm("graphlib__version02: .xdef graphlib__version02");

#define graphlib_fill graphlib__0000
void	graphlib_fill(unsigned short x asm("d0"), unsigned short y asm("d1"), unsigned short width asm("d2"), unsigned short height asm("d3"), unsigned short color asm("d4"));

#define graphlib_put_sprite graphlib__0001
void	graphlib_put_sprite(unsigned short x asm("d0"), unsigned short y asm("d1"), void *sprite asm("a0"));

#define graphlib_put_sprite2 graphlib__000C
void	graphlib_put_sprite2(unsigned short x asm("d0"), unsigned short y asm("d1"), void *sprite asm("a0"), unsigned char *mask asm("a2"));

#define graphlib_put_sprite_mask graphlib__000B
void	graphlib_put_sprite_mask(unsigned short x asm("d0"), unsigned short y asm("d1"), unsigned char mask asm("d3"), void *sprite asm("a0"));

#define graphlib_smallbox graphlib__0002
void	graphlib_smallbox(char *title asm("a0"));

#define graphlib_box graphlib__0003
void	graphlib_box(unsigned short x asm("d0"), unsigned short y asm("d1"), unsigned short width asm("d2"), unsigned short height asm("d3"), char *title asm("a0"));

#define graphlib_frame graphlib__0004
void	graphlib_frame(unsigned short x asm("d0"), unsigned short y asm("d1"), unsigned short width asm("d4"), unsigned short height asm("d5"));

#define graphlib_clrscr graphlib__0005
void	graphlib__clrscr();

#define graphlib_clrscr2 graphlib__0014
void	graphlib__clrscr2();

#define graphlib_vert graphlib__0006
void	graphlib_vert(unsigned short x asm("d0"), unsigned short y1 asm("d1"), unsigned short y2 asm("d2"));

#define graphlib_horiz graphlib__0007
void	graphlib_horiz(unsigned short x1 asm("d0"), unsigned short y asm("d1"), unsigned short x2 asm("d2"), unsigned short color asm("d3"));

#define graphlib_bigbox graphlib__0008
void	graphlib_bigbox(char *title asm("a0"));

#define _graphlib_scrtomem graphlib__0009
void	_graphlib_scrtomem(unsigned short x asm("d0"), unsigned short y asm("d1"), unsigned short width asm("d2"), unsigned short height asm("d3"));
#define graphlib_scrtomem(_x, _y, _height, _width) ({register unsigned short __d4 asm("d4"); _graphlib_scrtomem(_x, _y, _height, _width); __d4;})

#define graphlib_memtoscr graphlib__000A
void	graphlib_memtoscr(unsigned short x asm("d0"), unsigned short y asm("d1"), unsigned short width asm("d2"), unsigned short height asm("d3"), HANDLE hd asm("d4"));

#define graphlib_line graphlib__0017
void	graphlib_line(unsigned short x1 asm("d0"), unsigned short y1 asm("d1"), unsigned short x2 asm("d2"), unsigned short y2 asm("d3"), void *screen asm("a0"));

#define graphlib_choosescreen graphlib__000D
extern unsigned short graphlib_choosescreen;

typedef struct {
	unsigned short x1;
	unsigned short y1;
	unsigned short x2;
	unsigned short y2;
	unsigned short x;
	unsigned short y;
	char	*str;
	} dialog_struct;
#define graphlib_show_dialog graphlib__0015
void	graphlib_show_dialog(dialog_struct *d asm("a6"));

#define graphlib_clear_dialog graphlib__0016
void	graphlib_clear_dialog();

#define graphlib_erase_rect graphlib__0018
void	graphlib_erase_rect(void *r);

#define graphlib_frame_rect graphlib__0019
void	graphlib_frame_rect(void *r);

#define graphlib_gray2 graphlib__000E
void	graphlib_gray2();

#define graphlib_gray4 graphlib__000F
void	graphlib_gray4();

#define graphlib_gray7 graphlib__0010
void	graphlib_gray7();

#define graphlib_plane0 graphlib__0011
#define graphlib_plane1 graphlib__0012
#define graphlib_plane2 graphlib__0013
extern unsigned char *graphlib_plane0;
extern unsigned char *graphlib_plane1;
extern unsigned char *graphlib_plane2;

//userlib
asm("userlib__version01: .xdef userlib__version01");

#define	userlib_idle_loop userlib__0000
short	userlib_idle_loop();
#define userlib_random	userlib__0001
short	userlib_random(short limit asm("d0"));
#define userlib_randseed userlib__0002
extern	short	userlib__randseed;
#define userlib_exec userlib__0003
__attribute__((__stkparm__)) short	userlib_exec(HANDLE handle);
#define userlib_inputstr userlib__0006
char	*userlib_inputstr(short x asm("d1"), short y asm("d2"), short maxlen asm("d3"));
#define	userlib_smallmenu userlib__000C
short	userlib_samllmenu(short x asm("d0"), short y asm("d1"), char nbitem asm("d2"), char *str_list asm("a0"));
#define userlib_runprog userlib__0010
short	userlib_runprog(char *progname asm("a0"));

// Hexlib
asm("hexlib__version01: .xdef hexlib__version01");

#define	hexlib_put_char	hexlib__0000
void	hexlib_put_char(long x asm("d2"), long y asm("d1"), long character asm("d0"));
#define hexlib_put_bin	hexlib__0001
void	hexlib_put_bin(long x asm("d2"), long y asm("d1"), long number asm("d0"), long digits asm("d4"));
#define	hexlib_put_hex	hexlib__0002
void	hexlib_put_hex(long x asm("d2"), long y asm("d1"), long number asm("d0"), long digits asm("d4"));

// Shrnklib
asm("shrnklib__version01: .xdef shrnklib__version01");

#define	shrnklib_OpenArchive	shrnklib__0000
HANDLE	shrnklib_OpenArchive(void *archive asm("a0"));
#define	shrnklib_CloseArchive	shrnklib__0001
void	shrnklib_CloseArchive(HANDLE arch_hd asm("d0"));
#define	shrnklib_Extract	shrnklib__0002
void	*shrnklib_Extract(HANDLE arch_hd asm("d0"), short index asm("d1"), void *dest asm("a0"));
#define	shrnklib_Free(ptr) HeapFree(HeapPtrToHandle(ptr))

//Ziplib
asm("ziplib__version01: .xdef ziplib__version01");

#define	ziplib_check_cmem	ziplib__0000
short	ziplib_check_cmem(void *data asm("a0"), unsigned short len asm("d0"));
#define	ziplib_check_emem	ziplib__0001
short	ziplib_check_emem(void *archive asm("a0"));
#define	ziplib_eval_cmem	ziplib__0002
short	ziplib_eval_cmem(void *data asm("a0"), unsigned short len asm("d0"));
#define	ziplib_eval_emem	ziplib__0003
short	ziplib_eval_emem(void *archive asm("a0"));
#define	ziplib_compress	ziplib__0004
short	ziplib_compress(void *data asm("a0"), unsigned short len asm("d0"), void *dest asm("a1"));
#define	ziplib_extract	ziplib__0005
short	ziplib_extract(void *archive asm("a0"), void *dest asm("a1"));
#define	ziplib_zipfile	ziplib__0006
char	ziplib_zipfile(SYM_ENTRY *sym asm("a0"), char comment asm("d1"));
#define	ziplib_iscomp	ziplib__000B
short	ziplib_iscomp(SYM_ENTRY *sym asm("a0"));
#define	_ziplib_tempfile	ziplib__0007
long long _ziplib_tempfile(SYM_ENTRY *sym asm("a0"), char comment asm("d1"));
#define	ziplib_tempfile(sym, comment) ({long long result__ = _ziplib_tempfile(sym, comment); (char)(result__>>32)?-(short)(char)(result__>>32):(short)result__;})
#define ziplib_extract_string	ziplib__0008
void	ziplib_extract_string(void *archive asm("a0"), short arch_index asm("d3"), short str_index asm("d4"), void *dest asm("a1"));
#define ziplib_write_string	ziplib__0009
void	ziplib_write_string(void *archive asm("a0"), short x asm("d0"), short y asm("d1"), short arch_index asm("d3"), short str_index asm("d4"));
#define ziplib_write_string_inv	ziplib__000A
void	ziplib_write_string_inv(void *archive asm("a0"), short x asm("d0"), short y asm("d1"), short arch_index asm("d3"), short str_index asm("d4"));

#endif
