; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;				PreOs	Kernel
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; 				OPTIONS
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

; Manual:
; Just Remove the ';' at the beginning of a line to define the option.

; Define it to have the H220xTSR version
; You can not define it if you have an HW1 calc, or HW2patch installed.
; If you don't define it, it will save some memory.
; If you define it, you must compil with :
;	tigcc preos.asm hw2tsr\h220xtsr.a
; So you must have installed Tigcc (See http://tigcc.ticalc.org)

;hw2tsr		set	1

; Define it to call a shell (even nostub program) with Shift+on.
;	NoDefine -> NoShell
;	1 -> shell (kernel)
;	2 -> TicTex (nostub)

;ShiftOn		set	2

; Restore TSR after a hot reset ?
; If you have installed other TSR than PreOs which use EV_hook,
; you MUST define it to reinstall properly your TSR after a Hot Reset.

RestoreTSR	set	1

; Display  window after the installation of PreOS
; If you define it, no window is displayed during the installation process.

;NoWindow	set	1

; Check if program compatible with Ti89 / Ti92+ / v200 before running it.
; Note: Some programs are designed to run only on 89, but nevertheless works fine on 92+.

;CheckCalc	set	1

; Allows every instruction in Basic function (Even global vars)

BasicFunction	set	1

; Supports Wti Program Break Point
; Usefull only if you have Wti :)

;WTI_BP	set	1

; Only HW1 : if you define this, Preos won't support Hw2.
; Never distribute such a version !

;strictHW1	set	1

; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

; Update: 3 kinds of update may come. Search for the code in the install process
;	to update PreOS. Search for the string :
;		Check if BOOT Update
;		Check if AMS Update
;		Check if HARDWARE Update
;	

; Bugs :
;	Bug avec txtrider ?
;	Bug avec Total Destruction ?
;	Bug avec ziplib + txtrider textes archives ?
;	Bug avec AMS 2.08 ?
; To Do :
;	Ameliorer l'auto run (Free preos) ?
;	kernel::LibsExec is NOT reentrant
;	To do a starter which install the kernel and then run a program.
;	Export all dirty Hacks of Tigcc : realloc, vcbprintf, HS_pushEmptyFIFONode, ... ?
;	Delete graphlib, userlib, filelib, pk92lib, (stdlib) & doorsos & install & kernel & teos

;	Remove $4C (...) & install_preos
;	addr = (AMS 1.00 ? xxx : cmd_try+xxx)
;	hd = Ptr2Hd(*addr);
;	if (Kernel Signature)
;		AutoRun = True
;		Prog Handle = hd // Pb a la sortie car Pack Archive auto-detruites !
;	else if (Argv[1] = file)
;		SymFind
;		if (Kernel Signature)
;			AutoRun = True;
;			Prog Handle = hd;
;	if (!AutoRun)
;		Install Hw2Tsr
;		Block = Alloc Space for block
;	else	Block = Inside Preos
;		Save Vectors
;		enter_ghost_space
;	Install Process
;	if (!AutoRun)
;		Display infos
;	else	Run program (Pb nostub anticrash ?)

	include "include/RomCalls.h"

	xdef 	_ti89
	xdef	_ti92plus
	xdef	_nostub

PREOS_VERSION	EQU	$FF67*65536+'PO'	; PreOs version
VERSION_OFFSET	EQU	$10			; Offset of the version number
IS89_0_2	EQU	0			; Compatibility with Pedrom
ROM_VECTOR	EQU	$012088			; Offset from ROM_BASE to get the original vectors

TI89		EQU	1
TI92P		EQU	1
V200		EQU	1

	ifd	hw2tsr
HW2TSR_PATCH	MACRO		; An register / Dn register
	exg	\1,\2		; Exchange register
	bset.l	#18,\2		; In the ghost space
	exg	\2,\1		; Exg register
		ENDM
	endif
	ifnd	hw2tsr
HW2TSR_PATCH	MACRO		; An register / Dn register
		ENDM
	ifnd	strictHW1
hw2patch	set	1	; hw2patch = ~hw2tsr & ~stricthw1
	endif
	endif

	include	"Wti.h"

_main:
	; Test if the call is from Ti-Home
	cmp.l	#$200000,(a7)
	bls	dont_install
	
	ifd	hw2tsr
		include	"hw2tsr\h220xtsr.h"
	endif

	movem.l d3-d7/a2-a6,-(a7)
	
	; Load Global registers
	move.l	a7,a6			; Saving Sp
	move.l	($C8).w,a5		; Rom_calls ptr
	
	; Test presence kernel...
	lea	already(Pc),a0
	tst.w	($30).w			; Regarde si un kernel est dj install
	bne	exit

	; Get ROM_BASE and check it.
	move.l	a5,d0
	andi.l	#$600000,d0
	move.l	d0,a4			; Rom_base
	
	; 0 : Detection of Calc / Hardware and RomBase
	; Detection of calc (Check if BOOT Update).
	move.l	260(a4),a1		; HardwareParmBloc
	move.w	(a1)+,d1		; Read and skip size
	move.l	(a1)+,d2		; Read Calculator ( 1 : 92+ / 3 : 89 / V200 : 8)
	move.l	(a1)+,d5		; Read Hardware Revision version
	moveq	#1,d3			; HW_VERSION = 1
	cmpi.w	#$16,d1			; AMS reads Gate Array field to
	bls.s	\hw1			; see which hardware it is.
		move.l	($16-2-4-4)(a1),d3	; Read HW_VERSION
\hw1	

	; Detection of Emulator ? (Change calc / hw_version)  (Check if EMULATOR Update).
	clr.b	d4			; Emulator = False
	trap	#12         	; enter supervisor mode.
	IS_WTI.s	\emu
	; Vti detection by JM (1)
	;move.w	#$3000,sr 	; set a non-existing flag in sr
	;move.w	sr,d1
	;move.w	d0,SR		
	;moveq	#1,d0		; 92+ Version
	;btst	#12,d1		; this non-existing flag can only be set on VTI
	;beq.s	\real_calc
	; Vti detection by JM (2)
	moveq	#-97,d1
	nbcd	d1
	bmi.s	\real_calc
\emu:		st.b	d4		; EMULATOR = TRUE
		moveq	#1,d3		; HW1
		cmp.w	#$1400,(a4)	; Check if it is a TIB
		bne.s	\real_calc	; It is not a TIB, so HARDWARE PARM BLOC exists !
			moveq	#1,d2		; 92 + Version
			cmp.l	#$400000,a4
			beq.s	\real_calc
				moveq	#3,d2	; 89
\real_calc
	move.w	#0,SR
	
	; Translate calculator from Ti format to kernel format
	moveq	#1,d0			; 92+ Version
	subq.w	#1,d2			; Yes
	beq.s	\did		
		moveq	#0,d0		; 89
		subq.w	#2,d2
		beq.s	\did		; Yes
			moveq	#3,d0	; V200
\did
	
	;1 : save calc/hardware
	lea	valeursRAMti89(pc),a0
	lea	Calc(pc),a3
	move.b	d0,(a3)+		; Save Calculator
	beq.s	\ti89			
		lea	valeursRAMti92(pc),a0
\ti89	move.b	d3,(a3)+		; Save Hardware Version
	move.b	d5,(a3)+		; Save HW_REVISION_VERSION (Useless)
	move.b	d4,(a3)+		; Save Emulator Flag
	lea	RAM_TABLE+4(pc),a3
	
	; 1' Fix CheckCalc offset
	ifd	CheckCalc
		lea	ChkCalc+2(Pc),a1
		moveq	#1,d1			; 89
		tst.b	d0
		beq.s	\Chk_done
			moveq	#0,d1		; 92+
			subq.w	#1,d0
			beq.s	\Chk_done
				moveq	#5,d1	; v200
\Chk_done	move.w	d1,(a1)
	endif

	; 1'' Copy 89/92-v200 values
	moveq	#12,d0
\copieRAM:	move.l	(a0)+,(a3)+
		dbf	d0,\copieRAM
	move.l	a4,-4*11(a3)		; Save Rom_Base

	;2 : Find FontMedium (It takes only 0.02s to find it.) (Check if BOOT Update).
	move.l	a4,a0
\fontloop:	cmp.l	#$54A854A8,(a0)+
		bne.s	\fontloop
	subq.l	#4,a0
	move.l	a0,(a3)+
	clr.l	(a3)+			; ReturnValue is calculated later.

	;3: Find tios::kb_vars (Check if AMS Update).
	moveq	#6,d0			; 6 = Key Queue address
	trap	#9			; Call system
	lea	($6-$1C)(a0),a0		; Fix to get kb_vars
	move.l	a0,(a3)+

	; 3': Find tios::ST_statut (All ROM. On rom 2.0x there is a rom_call )
	ifd	ShiftOn				; (Check if AMS Update).
		FAST_ROM_PTR ST_precision,a5	; Code looks like : andi.l #$FFFFFE7F,ST_statut
		move.w	6(a0),d0		; Read ST_statut
		addq.w	#3,d0
		lea	Statut+3(Pc),a1
		moveq	#1,d1			; Bit : 1 for 89 / 2 for 92+ & V200 
		move.b	Calc(Pc),d2
		beq.s	\this89
			moveq	#2,d1
\this89		move.b	d1,(a1)+	
		move.w	d0,(a1)			; Statut ADR
	endif
	
	;4: Find Heap (All ROM. On rom 2.0x there is a rom_call ) (Check if AMS Update).
	FAST_ROM_PTR HeapDeref,a5
\heap_loop	cmp.w	#$2078,(a0)+		; movea.l ?
		bne.s	\heap_loop
	movea.w	(a0),a0
	move.l	a0,(a3)+			; tios::Heap

	;5: Find main, its handle and the handle of FolderListHandle
	pea	main_str_end(Pc)
	FAST_ROM_CALL SymFindHome,a5
	move.l	d0,d1
	clr.w	d1
	swap	d1
	move.l	d1,(a3)+	; FolderHandle
	move.l	d0,(a7)
	FAST_ROM_CALL DerefSym,a5
	move.w	SYM_ENTRY.hVal(a0),d0	;MainHandle
	moveq	#0,d1
	move.w	d0,d1
	move.l	d1,(a3)+	; MainHandle
	
	;6: Find the ROM version number.
	; Par Kevin Kofler (Modifie par PpHd)
	move.l	#$1100,d1		; Version : Ti-92+ Rom 1.00
	move.l	-4(a5),d2		; Get number of ROM CALLS
	cmp.w	#cmd_table,d2 		; Check if cmd_table is defined
	bcs.s	\save			; Rom Call cmd_table isn't defined : ROM 1.00
		move.l	cmd_table*4(a5),a0
		lea	-$10(a0),a0 	; Get address of AMS version
		cmpi.w	#$440,d2 	; Check if AMS version ROM_CALL is present
		bls.s	\getversion
			move.l	$440*4(a5),a0 	; Get address of AMS version ROM_CALL
\getversion:
		moveq	#$30,d0 
		move.b	Calc(Pc),d1
		lsl.w	#4,d1
		add.b	(a0),d1
		sub.b	d0,d1
		lsl.w	#4,d1
		addq.l	#2,a0
		add.b	(a0)+,d1
		sub.b	d0,d1
		lsl.w	#4,d1
		add.b	(a0)+,d1
		sub.b	d0,d1
\save:	move.l	d1,(a3)+

	; Find LCD_MEM (Hum) 
	lea	4*($21-$15)(a3),a3
	move.l	#LCD_MEM,(a3)+
	
	; Find font_small (It takes only 0.02s to find it.) (Check if BOOT Update).
	move.l	a4,a0
\fontsmall_loop	cmp.l	#$0450A050,(a0)+
		bne.s	\fontsmall_loop
	subq.l	#4,a0
	move.l	a0,(a3)+
	
	; Find font_medium (It takes only 0.02s to find it.) (Check if BOOT Update).
	move.l	a4,a0
\fontmed_loop	cmp.l	#$55AA55AA,(a0)+
		bne.s	\fontmed_loop
	subq.l	#4,a0
	move.l	a0,(a3)+

	; Desciption of a SYM_ENTRY struct
	moveq	#0,d0
	move.l	d0,(a3)+	; Name
	moveq	#8,d0
	move.l	d0,(a3)+	; Compat
	moveq	#10,d0
	move.l	d0,(a3)+	; Flags
	moveq	#12,d0
	move.l	d0,(a3)+	; hVal
	moveq	#14,d0
	move.l	d0,(a3)+	; sizeof
	
	ifd	hw2patch
	;7 : hardware 2 & Not Hw2Tsr ?
	move.b	Hw(pc),d0
	subq.b	#1,d0
	ble.s	\_hw1
		; Check if there is HW2Patch sur Rom 2.0x par KK (Check if AMS + HW2 Update).
		cmp.l	#1000,-4(a5)	; Check if > 1000 entries (AMS 2.0x)
		bcs.s	\_hw1
		FAST_ROM_PTR EX_stoBCD,a5	; Well, the function which follows EX_stoBCD is the protect function
		tst.w	92(a0)		; Check for HW2Patch (ROM resident)
		beq.s	\_hw1		; Ok, there is HW2 Patch
		cmp.l	#$100,($ac).w	; Check for HW2Patch (RAM resident)
		beq.s	\_hw1		; Ok, there is HW2 Patch (Trap B is intercepted)
			lea	hw2patch_str(Pc),a0
			bra	exit
\_hw1:
	endif

	; 8 Gestion EV_hook
	FAST_ROM_PTR EV_hook,a5
	lea	EV_hook2+2(pc),a1
	move.l	a0,(a1)				; Save EV_hook during kernel calls.
	ifd	RestoreTSR
		move.l	a0,EV_hook3-EV_hook2(a1)
	endif
	move.l	a0,EV_hook4-EV_hook2(a1)
	
	; 9 Gestion idle
	ifd	RestoreTSR
		FAST_ROM_PTR idle,a5		; (Check if AMS Update).
		lea	idleN+2(pc),a1
		move.w	2(a0),(a1)		; get idle number identification
	endif
		
	; 9' : Gestion top_estack	(<= SHIFT+ ON)
	ifd	ShiftOn
		FAST_ROM_PTR	top_estack,a5
		lea	top_estack1+2(pc),a1
		move.w	a0,(a1)
		move.w	a0,(top_estack2-top_estack1)(a1)
	endif
		
	; 10: Gestion intiale value of contrast
	moveq	#4,d0
	trap	#9				; (Check if AMS Update).
	lea	orgcontrast+3(Pc),a1
	move.b	(a0),d0
	subq.b	#1,d0
	move.b	d0,(a1)+	; Save Contrast Value
	move.w	a0,(a1)		; Save Contrast addr

	; 11: Find the address of the error-frame list 
	FAST_ROM_PTR ER_success,a5		; Get ER_success ptr
	lea	ErrorFrameAdr+2(pc),a1		;(Check if AMS Update).
	move.w	2(a0),d0
	move.w	d0,(a1)
	move.w	d0,ErrorFrameAdr2-ErrorFrameAdr(a1)
	move.w	d0,ErrorFrameAdr3-ErrorFrameAdr(a1)
	
	; 12: Find the original address of the user-stack (Check if AMS Update).
	move.w	#$4400,d0	; Org USP value on AMS 1.0x
	cmp.l	#1000,-4(a5)	; Check if > 1000 entries to test AMS 2.0x
	bcs.s	\_ams1
		move.w	#$4200,d0	; Org USP value on AMS 2.0x
\_ams1	lea	StackPtr+2(Pc),a1
	move.w	d0,(a1)
	
	; 12 Find 3 secret functions of AMS (Check if AMS Update).
	; Recherche de trois fonctions d'AMS cachees
	; Attention, c'est assez complique a trouver (mais indispensable).
	; Un clr.l FirstWindow n'est pas suffisant sur AMS 2.03 :(
	; C'est pour ca que je recherche ces fonctions !
	move.l	a5,d0
	andi.l	#$600000,d0		; Get ROM_base
	add.l	#$012088+4,d0		; Get Vector Table
	move.l	d0,a1
	move.l	(a1),a1			; Read Org Reset vector
					; FIX ME : move.l ($4).w,a1 may be ok ?
	; The searched code looks like
	; move.l #$DEADDEAD,$4200
	; clr.l $5D86
	; bsr.s 
	; bsr.s 
	; bsr.s 
	; bsr.s 
	; bsr.s 
	; bsr.s 
	; bsr.s +$36			; The first  function we search
	; move.w #$00,SR
	; jmp tios::EV_CentralDispatcher
\search_dead:
		subq.l	#2,a1
		cmp.l	#$DEADDEAD,(a1)+
		bne.s	\search_dead
	FAST_ROM_PTR EV_centralDispatcher,a5
\search_EV
		subq.l	#2,a1
		cmp.l	(a1)+,a0
		bne.s	\search_EV
	move.l	($41248C-$412462+2)(a1),a1	; The searched function is in a1
	; Now it looks like
	;link	a6
	;tst.l	$5D7C
	;bne.s 
	;jsr	$			; The 1st : Reset a flag (I don't know what it does exactly !)
	;jsr	$			; The 2nd : Reset PortRestore / SetCurrentClip / ScreenClear(:() / FontSetSys + Some flags
	;jsr	$			; The 3rd : Reset the window list + Some Flags
	lea	AMS_HiddenFunc+2(Pc),a0
	move.l	12+6(a1),(a0)		; Read the 2nd function.
	move.l	12+6+6(a1),6(a0)	; Read the 3rd function.

	;13 : Alloc memory
	pea	(blocfin-bloc).w
	FAST_ROM_CALL HeapAllocHigh,a5
	move.w	d0,(a7)
	bne.s	\inst
		lea	memory(Pc),a0
		bra	exit
\inst	

	;14 : Path ROMBASE (a4)
	lea	ROMBASE1+2(Pc),a1
	move.l	a4,d0
	add.l	d0,(a1)
	add.l	d0,(ROMBASE2-ROMBASE1)(a1)
	add.l	d0,(ROMBASE3-ROMBASE1)(a1)
	add.l	d0,(ROMBASE4-ROMBASE1)(a1)
	
	;14' : Install Kernel infos (Check if HARDWARE Update).
	lea	$40030,a4
	move.l	#PREOS_VERSION,(a4)+	; $30=version + $FF for protection against the jsr /jmp $0 / $32=identifiant

	move.w	(a7),$14(a4)		; $48=handle du bloc

	FAST_ROM_CALL HeapDeref,a5	; Deref the Handle a0

	HW2TSR_PATCH	a0,d0		; Patch
	
	; 15 Install interrupts
	lea	crash_handler-bloc(a0),a2		; Install crash handler
	moveq	#7-1,d0
	lea	($40000+$8+$4),a3
\loop_handler:		move.l  a2,(a3)+		; Install new one
			dbra    d0,\loop_handler

	; NOTE: On all roms, there is a move.w $00,d0 (You can get it by setting a data break point to 0, and go to graph mode).
	; I think it is a bug in AMS, since it is non-sens.
	
	lea	newER_throw-bloc(a0),a2	;l'adresse o sera ER_throw
	lea	OldER_throw+2(Pc),a3
	move.l	-12(a4),(a3)		;$28
	move.l	a2,-12(a4)		;$28

	lea	new1111-bloc(a0),a2	;l'adresse o sera LineEmulator 1111
	move.l	a2,-8(a4)		;$2C

	lea	oldint6+2(Pc),a2
	move.l	($64+5*4).w,(a2)
	lea	newint6-bloc(a0),a1
	move.l	a1,$40064+5*4

	; 16 RAMCALLS gestion (end part)
	lea	RAM_TABLE(pc),a3
	lea	Calc-bloc(a0),a2	;l'adresse o sera CALC
	move.l	a2,(a3)			;place l'adresse de CALC

	lea	RetVal-bloc(a0),a2	; L'adresse ou sera RetVal
	move.l	a2,($F*4)(a3)		; Sauver

	lea	($15*4)(a3),a1
	lea	kernel::idle-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::exec-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::Ptr2Hd-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::Hd2Sym-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::LibsBegin-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::LibsEnd-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::LibsCall-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::LibsPtr-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::LibsExec-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::HdKeep-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::ExtractFromPack-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::ExtractFile-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::ExtractFileFromPack-bloc(a0),a2
	move.l	a2,$29*4(a3)
	
	; 17: Special values for 89/92p of the kernel (Check if HARDWARE Update).
	move.w	#(LCD_MEM+30*(100-7)),d1	; Valeur 89	
	move.w	#%0111111,d2			; Key Mask pour ESC
	clr.w	d3				; Key Bit pour ESC
	move.b	Calc(Pc),d0
	beq.s	\s89
		move.w	#LCD_MEM+30*(128-7),d1	; Valeur 92
		move.w	#%1011111111,d2		; Key Mask pour ESC
		moveq	#6,d3			; Key Bit pour ESC
		moveq	#2,d0			; offset = 2 for 92+ / V200
\s89	
	lea	ExtraRamCalc+3(Pc),a2		; Sauve l'offset de l'extraram call
	move.b	d0,(a2)
	lea	blackline+2(Pc),a2		; Sauve l'adresse de la ligne noire
	move.w	d1,(a2)
	lea	int6msk+2(Pc),a2		; Sauve le masque
	move.w	d2,(a2)
	lea	int6key+2(Pc),a2		; Sauve le champ de bit
	move.w	d3,(a2)

	; 17' Fix some things for  V200 (Check if HARDWARE Update).
	lea	Calc(Pc),a1
	move.l	(a1)+,d0
	move.l	d0,(a1)				; Copy calculator
	move.b	#1,(a1)				; We say 92+ (Even on 89 : we don't care, since the next patch will erase the code which may falsify _RAM_CALL_000).
	
	lsl.l	#7,d0				; V200 = 3*128 > 256
	bcs.s	\v200
		lea	v200_92p_patch(Pc),a1
		moveq	#(v200_92p_patch_end-v200_92p_patch)/2-1,d0
\v200_loop		move.w	#$4E71,(a1)+	; Fill with NOP
			dbf	d0,\v200_loop
\v200	

	; 18 Gestion valeur hw1/hw2 du kernel (Check if HARDWARE Update).
	; Valeur originelle du timer $17
	moveq	#$FFFFFFB2,d1			; Valeur Hw1
	move.b	Hw(Pc),d0
	subq.b	#1,d0
	ble.s	\this_hw1
		moveq	#$FFFFFFCC,d1		; Valeur Hw2
		cmp.w	#1000,-2(a5)		; Check if > 1000 entries (AMS 2.0x)
		bcs.s	\this_hw1
			move.l	EX_stoBCD*4(a5),a1	; Well, the function which follows EX_stoBCD is the protect function
			tst.w	92(a1)		; Check for ROM resident HW2Patch
			bne.s	\this_hw1	; Not ROM resident HW2 Patch
				lea	t4call+4(Pc),a1
				move.l	($90).w,(a1) ; Save Org Trap #4
				lea	Trap4-bloc(a0),a1
				move.l	a1,($40090) ; Save New Trap #4
\this_hw1
	lea	hwtimer+3(Pc),a2		; Sauve la valeur
	move.b	d1,(a2)
	
	; 19 Relocation du trap #0
	ifd	ShiftOn
		lea	NewTrap0-bloc(a0),a1
		lea	Trap0Adr+2(Pc),a2
		move.l	a1,(a2)
	endif
	
	ifd	RestoreTSR
		lea	ResetTrap0-bloc(a0),a1
		lea	resetTrap0Adr+2(Pc),a2
		move.l	a1,(a2)
	endif
		
	; 20 : Gestion AMS 2.07 and more (Use a2 instead of a3 in new ER_throw) (Check if AMS Update).
	move.w	-2(a5),d0
	cmpi.w	#$0607,d0
	blt.s	\Not_AMS207
		lea	AMS207_P1(Pc),a1
		move.w	#$0C12,(a1)			; cmpi.b #$F3,(a2)
		move.w	#$B5FC,AMS207_P2-AMS207_P1(a1)	; cmp.l #$200000,a2
\Not_AMS207

	; 21 Write standard exported functions.
	move.l	a0,(a4)+		; exec function is the first one
	lea	reloc-bloc(a0),a1
	move.l	a1,(a4)+
	lea	reloc2-bloc(a0),a1
	move.l	a1,(a4)+
	lea	unreloc-bloc(a0),a1
	move.l	a1,(a4)+
	lea	unreloc2-bloc(a0),a1
	move.l	a1,(a4)+
	lea	ExeArchive-bloc(a0),a1
	move.l	a1,$40050

	; 21 Copy the kernel into a Terminate and stay resident Handle
	lea	bloc(pc),a1
	move.w	#(blocfin-bloc)/2-1,d0
\copy:		move.w	(a1)+,(a0)+
		dbra	d0,\copy
	; The KERNEL is installed

	lea	-1000(a7),a7
	move.l	a7,a4
	move.w	#(blocfin-bloc),-(a7)
	pea	success(pc)
	pea	(a4)
	ROM_THROW sprintf
	move.l	a4,a0			; Vicieux ;)

	; In: a0-> String to print
exit:
	ifnd	NoWindow
		pea	(1).w
		pea	(a0)
		pea	title(pc)
		FAST_ROM_CALL DlgMessage,a5		; Can be called even if UniOs is installed !
	endif
	ifd	NoWindow
		pea	(a0)
		FAST_ROM_CALL	ST_showHelp,a5
	endif

	; Install new auto-ints and ev_hook
	moveq	#7-1,d0
	lea	($40064),a1
	lea	($400E0-$40064)(a1),a2
\loop_autoint:	move.l  (a1)+,(a2)+	; Save old handler
		dbra    d0,\loop_autoint

	; Search for outdated libs & multiple reference lib
	ifnd	NoWindow
		move.w	#2,-(a7)		; Parcourt de l'ensemble de la VAT
		clr.l	-(a7)
		FAST_ROM_CALL SymFindFirst,a5
		move.l	a7,a4			; Lib ptr
\loop			lea	mmauvaise(Pc),a1
			move.w	SYM_ENTRY.hVal(a0),-(a7)	; Push handle
			move.l	(a0)+,d6
			move.l	d6,(a1)+
			move.l	(a0)+,d7
			move.l	d7,(a1)+		; Copy lib name
			FAST_ROM_CALL HeapDeref,a5
			addq.l	#2,a7
			moveq	#0,d0
			move.w	(a0)+,d0
			cmp.b	#$F3,-1(a0,d0.l)
			bne.s	\next2
				cmp.l	#'68kL',4(a0)			; On gere pas encore les packs archives
				bne.s	\next2
					tst.b	VERSION_OFFSET(a0)	; Updated Libs
					bne.s	\next	
						move.l	#1*65536+4,-(a7)
						pea	mwrong(Pc)
						FAST_ROM_CALL SymFindFoldername,a5
						pea	(a0)
						FAST_ROM_CALL DlgMessage,a5
						lea	12(a7),a7
						cmp.w	#13,d0
						bne.s	\stop_lib
\next					; Check for multiple lib refs
					move.l	a7,a0
					bra.s	\search_cmp
\search_loop					cmp.l	(a0),d6
						bne.s	\search
						cmp.l	4(a0),d7
						bne.s	\search
							addq.w	#1,8(a0)	; Add one more
							bra.s	\next2
\search:					lea	10(a0),a0
\search_cmp:					cmp.l	a0,a4
						bne.s	\search_loop
					; Add this library
					clr.w	-(a7)
					move.l	d7,-(a7)
					move.l	d6,-(a7)
\next2			FAST_ROM_CALL SymFindNext,a5
			move.l	a0,d0
			bne	\loop
		; Check for Multiple Ref lib
		move.l	a7,a3
		bra.s	\mult_cmp
\multiple_loop
			tst.w	8(a3)			; Check if there is only one lib
			beq.s	\mult_next
				move.l	#1*65536+4,-(a7)
				pea	(a3)
				pea	mult_str(pc)
				FAST_ROM_CALL DlgMessage,a5
				lea	12(a7),a7
				cmp.w	#13,d0
				bne.s	\stop_lib
\mult_next:		lea	10(a3),a3
\mult_cmp:		cmp.l	a3,a4
			bne.s	\multiple_loop
\stop_lib
	; Search for outdated programs

	endif

	move.l	a6,a7			; Pop Stack
	
	; Test if run program
	move.l	($4C).w,d0
	beq.s	\no_run
		; To do : Reduce Preos space if it was a twin entry.
		;	lea	0(pc),a0
		;	bsr	kernel::Ptr2Hd
		;	bsr	Hd2Sym
		;	btst.b	#,SYM_ENTRY.flags(a0)
		;	...
		;		Copy code de reduction, de code d'execution, de desinstallation dans la RAM a addr fixe (HW2TSR) -Stack
		;		saut 
		clr.l	$4004C
		move.l	d0,a0
		bsr	kernel::Ptr2Hd
		bsr	kernel::exec		; Bugs ? Nan
		; To do Uninstall : pb hw2tsr.........................................................
		; In Tictex, si kernel prgm et pas kernel ($30), call preos() en mettant a $4C l'adresse du programme ?
\no_run	
	; Quit program
	movem.l (a7)+,d3-d7/a2-a6
dont_install
	rts
	
valeursRAMti89 dc.l 160,100,$200000,20,338,344,337,340,345,342,$4000,2000,$2000
valeursRAMti92 dc.l 240,128,$400000,30,337,340,338,344,342,345,$2000,3840,$4000

; Terminate and Stay Resident Part of Preos
bloc:
	include Exec.asm		; Exec Kernel Programs
	include	Reloc.asm		; Reloc Kernel Programs
	include Ints.asm		; Interrupts
	include	ext.asm			; External Functions
	NEW_TRAP4			; Trap #4 if Hw2Patch
blocfin:

	; Strings
	ifnd	NoWindow
title		dc.b "PreOS v0.67"		; Title
	ifd	hw2tsr
		dc.b "-Hw2TSR"			; Hw2Tsr Title
	endif
	ifeq	ShiftOn-1
		dc.b "-shell"
	endif
	ifeq	ShiftOn-2
		dc.b "-tictex"
	endif
	ifd	RestoreTSR
		dc.b "-RTSR"
	endif
	ifd	CheckCalc
		dc.b "-CheckCalc"
	endif
		dc.b 0
	endif
success		dc.b "Success ! (%u bytes)",0
already		dc.b "Update auto-ints.",0
	ifd	hw2patch
hw2patch_str	dc.b "Install HW2Patch first",0
	endif
	endif
mult_str	dc.b "Several libs with same name",0
memory		dc.b "Not enought memory",0
		dc.b	0,"main"
main_str_end	dc.b	0

	end
	